//$Id: StateDescriptor.java,v 1.1.1.1 2006/08/29 10:01:05 guy Exp $
//$Log: StateDescriptor.java,v $
//Revision 1.1.1.1  2006/08/29 10:01:05  guy
//Import of 3.0 essentials edition.
//
//Revision 1.1.1.1  2006/04/29 08:55:37  guy
//Initial import.
//
//Revision 1.1.1.1  2006/03/29 13:21:27  guy
//Imported.
//
//Revision 1.1.1.1  2006/03/23 16:25:27  guy
//Imported.
//
//Revision 1.1.1.1  2006/03/22 13:46:53  guy
//Import.
//
//Revision 1.2  2006/03/15 10:31:35  guy
//Formatted code.
//
//Revision 1.1.1.1  2006/03/09 14:59:07  guy
//Imported 3.0 development into CVS repository.
//
//Revision 1.4  2005/08/05 15:03:34  guy
//Merged-in changes/additions of redesign-5-2004 (SOAP development branch).
//
//Revision 1.3  2004/10/12 13:03:30  guy
//Updated docs (changed Atomikos to Atomikos in many places).
//
//Revision 1.2  2004/03/22 15:37:33  guy
//Merged-in changes from branch redesign-4-2003.
//
//Revision 1.1.10.1  2003/06/20 16:31:37  guy
//*** empty log message ***
//
//Revision 1.1  2002/03/10 12:48:46  guy
//Updated admintool facility to use lists for all messages.
//
//Revision 1.1  2002/03/09 23:51:07  guy
//Added provisions for improved display of AdminTool.
//


              
/*
 * Copyright 2000-2008, Atomikos (http://www.atomikos.com) 
 *
 * This code ("Atomikos TransactionsEssentials"), by itself, 
 * is being distributed under the 
 * Apache License, Version 2.0 ("License"), a copy of which may be found at 
 * http://www.atomikos.com/licenses/apache-license-2.0.txt . 
 * You may not use this file except in compliance with the License. 
 *             
 * While the License grants certain patent license rights, 
 * those patent license rights only extend to the use of 
 * Atomikos TransactionsEssentials by itself. 
 *             
 * This code (Atomikos TransactionsEssentials) contains certain interfaces 
 * in package (namespace) com.atomikos.icatch
 * (including com.atomikos.icatch.Participant) which, if implemented, may
 * infringe one or more patents held by Atomikos.  
 * It should be appreciated that you may NOT implement such interfaces; 
 * licensing to implement these interfaces must be obtained separately from Atomikos.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  
 */
 
package com.atomikos.icatch.admin.imp;

import com.atomikos.icatch.HeuristicMessage;

/**
 * 
 * 
 * A descriptor class containing state, message pairs.
 */

class StateDescriptor
{
    /**
     * The object denoting the state.
     */

    public Object state;

    /**
     * The heuristic message that goes with it.
     */

    public HeuristicMessage[] messages;

    /**
     * Create a new instance.
     * 
     * @param state
     *            The state.
     * @param messages
     *            The messages describing the work done.
     */

    public StateDescriptor ( Object state , HeuristicMessage[] messages )
    {
        this.state = state;
        this.messages = messages;
    }
}
